/**
  Pointers to functions themselves.
  Not as critical for this class, but know it exists.
 **/

#include <iostream>
using namespace std;

int addition(int a, int b)
{
    return a + b;
}

int subtraction(int a, int b)
{
    return a - b;
}

int oper(int x, int y, int (*funct)(int, int))
{
    int g;
    g = (*funct)(x, y);
    return g;
}

int main()
{
    int m, n;
    m = oper(7, 5, addition); //*func or func ok
    cout << m << endl;

    int (*minusFunc)(int, int) = subtraction; // ??
    n = oper(20, m, minusFunc); //*func or func ok
    cout << n;

    return 0;
} // *addition and *minusFunc or addition and minusFunc work above, why?
