/**
Pointers to structs (and other user defined objects).
**/

#include <iostream>
using std::cout;
using std::endl;

struct person
{
    std::string name;
    int age;
};

int main()
{
    person aPerson;
    person *pPerson;
    pPerson = &aPerson;
    pPerson->age = 23;
    cout << pPerson->age << endl; // out: 23

    //*pPerson.age = 25; // won't work, op. order
    (*pPerson).age = 25; //works
    pPerson[0].age = 25; //works, crazy to use though. Why?
    cout << pPerson->age << endl; // out: 25

    person personArray[4]; // array of people
    personArray[2].age = 22; // works
    (*(personArray+2)).age = 23; // why??
    cout << personArray[2].age << endl; // out: 22

    return 0;
}
