/**
Pointers returned from functions
**/

#include <iostream>
using std::cout;
using std::endl;

int * getRandom()
{
    srand((unsigned)time(nullptr)); // set seed
    static int r[10];

    cout << "Generating random numbers:" << endl;
    for(int i = 0; i < 10; ++i)
    {
        r[i] = rand();
        cout << r[i] << endl;
    }

    return r;
}

int main()
{
    int *p;
    p = getRandom();

    cout << "\nRandom array returned:" << endl;
    for( int i = 0; i < 10; i++ )
    {
        cout << "*(p+" << i << "): " << *(p+i) << endl;
    }
    cout << endl;

    for( int i = 0; i < 10; i++ )
    {
        cout << "p[" << i << "]: " << p[i] << endl;
    }

    return 0;
}
