/**
Pointers to classes
**/

#include <iostream>
using namespace std;

class Rectangle
{
    private:
        int width, height;

    public:
        Rectangle(int x, int y): width(x), height(y){}

        Rectangle()
        {
            width = 5;
            height = 4;
        }

        int area(void)
        {
            return width * height;
        }
};

int main()
{
    Rectangle aRect(3, 4);
    Rectangle *pRect = &aRect;
    cout << pRect->area() << endl; // 12
    cout << (*pRect).area() << endl; // 12

    Rectangle arrRect[4];
    cout << arrRect[2].area() << endl; // 20
    cout << (*(arrRect + 2)).area() << endl; // 20
    //cout << *(arrRect + 2).area() << endl; // does not work, be explicit with pointers!

    return 0;
}
